'	Lucid Image Editor
' keys:
'  left mouse button: select (menu item), put paint color pixel
'  right mouse button: put paper color pixel
'  "-" : zoom out
'  "=" (+, just don't use the shift key): zoom in
'  "g", "G": turn the 'g'rid on or off (unless zoom = 100%)
'  "v", "V": 'v'iew the image at 100% and tiled
'  "f", "F":  'f'ill the entire image with paint color
'  |esc|:  bring up the menu

defint a-z

DECLARE SUB fillTool ()
DECLARE SUB loadpal (pal$)
DECLARE FUNCTION getString$ (x, y, maxlength)
DECLARE SUB drawXscroll ()
DECLARE SUB drawYscroll ()
DECLARE SUB scroll (x, y)
DECLARE SUB ResumeImgSub ()
DECLARE SUB delay (dly!)
DECLARE SUB selectColor ()
DECLARE SUB UpdateInfo ()
DECLARE SUB saveImgSub (fileName$, imgArraySize)
DECLARE SUB loadImgSub (fileName$, imgArraySize)
DECLARE SUB loadImgInfoSub (imgFileName$)
DECLARE SUB eyeDropperTool ()
DECLARE SUB viewTiled ()

DECLARE SUB limitRange (x1, y1, x2, y2)
DECLARE SUB MouseDriver (Ax, Bx, Cx, Dx)
DECLARE SUB mouseHide ()
DECLARE SUB MouseLoad ()
DECLARE SUB mouseShow ()
DECLARE SUB mousePut (x, y)
DECLARE SUB mouseStatus (lb, rb, MouseX, MouseY)
DECLARE FUNCTION inRange (x1, y1, x2, y2)
DECLARE FUNCTION MouseInit ()

TYPE paltype
 r AS INTEGER
 g AS INTEGER
 B AS INTEGER
END TYPE

'$DYNAMIC

'Arrays and variables
DIM SHARED Mouse$, lb, rb, MouseX, MouseY, pal(255) AS paltype, zRatio, imgXsize, imgYsize, paintColor, paperColor
DIM SHARED img%(16, 16), preImg%(16, 16), curXpos, curYpos, imgXoffSet, imgYoffset, numXpix, numYpix, delayTime!, previousColor(16), previousColorNum
'Flags
DIM SHARED editActive, savedLastAction, gridOn, xScroll, yScroll
DIM SHARED image%(130), imgArraySize

CONST BADFILENAME = 53, NORESUME = 19

'ON ERROR GOTO ErrorHandler


delayTime! = .04
editActive = 0
FOR i = 1 TO 16: previousColor(i) = 0: NEXT i
previousColorNum = 1
savedLastAction = 1

SCREEN 13: CLS

CALL MouseLoad

menu:
   CLS : PAINT (1, 1), 1: LINE (50, 40)-(272, 160), 9, B: PAINT (55, 55), 8, 9
	  IF editActive THEN COLOR 15 ELSE COLOR 8
	LOCATE 8, 8: PRINT "  Resume  ": LINE (54, 54)-(135, 65), 15, B: LINE (55, 55)-(134, 64), 0, B
	LOCATE 8, 20: PRINT "  Resize  ": LINE (150, 54)-(232, 65), 15, B: LINE (151, 55)-(231, 64), 0, B
	LOCATE 10, 20: PRINT " Settings ": LINE (150, 70)-(232, 81), 15, B: LINE (151, 71)-(231, 80), 0, B
	LOCATE 12, 20: PRINT "   Help   ": LINE (150, 86)-(232, 97), 15, B: LINE (151, 87)-(231, 96), 0, B
	  COLOR 15
	LOCATE 10, 8: PRINT "New Image ":  LINE (54, 70)-(135, 81), 15, B: LINE (55, 71)-(134, 80), 0, B
	LOCATE 12, 8: PRINT "Load Image": LINE (54, 86)-(135, 97), 15, B: LINE (55, 87)-(134, 96), 0, B
	  IF savedLastAction = 0 THEN COLOR 15 ELSE COLOR 8
	LOCATE 14, 8: PRINT "Save Image": LINE (54, 102)-(135, 113), 15, B: LINE (55, 103)-(134, 112), 0, B
	  COLOR 15
	LOCATE 16, 8: PRINT " Load Pal ": LINE (54, 118)-(135, 129), 15, B: LINE (55, 119)-(134, 128), 0, B
	LOCATE 18, 8: PRINT "   Exit   ": LINE (54, 134)-(135, 145), 15, B: LINE (55, 135)-(134, 144), 0, B

   CALL limitRange(50, 40, 273, 160): CALL mouseShow

  DO
   CALL mouseStatus(lb, rb, MouseX, MouseY)

   IF lb THEN
	IF inRange(54, 54, 135, 65) AND editActive THEN CALL mouseHide: CLS : PAINT (1, 1), 8: CALL limitRange(0, 0, 319, 199): GOSUB resumeImg
	IF inRange(151, 55, 231, 64) AND editActive THEN CALL mouseHide: CALL limitRange(0, 0, 319, 199): GOSUB resizeImg
	IF inRange(54, 70, 135, 81) THEN CALL mouseHide: CALL limitRange(0, 0, 319, 199): GOSUB newImg
	IF inRange(54, 86, 135, 97) THEN CALL mouseHide: CALL limitRange(0, 0, 319, 199): GOSUB loadImg
	IF inRange(54, 102, 135, 113) AND editActive THEN CALL mouseHide: CALL limitRange(0, 0, 319, 199): GOSUB saveImg
	IF inRange(54, 118, 135, 129) THEN GOSUB getPalInfo
	IF inRange(54, 134, 135, 145) THEN END
   END IF
  LOOP

newImg:
	CLS : PAINT (1, 1), 8
	zRatio = 10: gridOn = 1: editActive = 1: savedLastAction = 0
	imgXsize = 16: imgYsize = 16
	imgXoffSet = 0: imgYoffset = 0
	paperColor = 0: paintColor = 1
	 
	  FOR y = 1 TO imgYsize
	   FOR x = 1 TO imgXsize
		img%(x, y) = paperColor
	   NEXT x
	  NEXT y

resumeImg:
CALL ResumeImgSub
DO: CALL mouseStatus(lb, rb, MouseX, MouseY): LOOP UNTIL lb = 0 AND rb = 0
  
mainloop:
  DO
   j$ = INKEY$
   CALL mouseStatus(lb, rb, MouseX, MouseY)

     curXpos = INT((MouseX / 2) / zRatio)
     curYpos = INT(MouseY / zRatio)

	IF lb AND inRange(0, 0, (zRatio * numXpix) - 1, (zRatio * numYpix) - 1) THEN
		curXpos = INT((MouseX / 2) / zRatio)
		curYpos = INT(MouseY / zRatio)

	       CALL mouseHide: LINE ((curXpos * zRatio), (curYpos * zRatio))-((curXpos * zRatio) + zRatio - 1 - gridOn, (curYpos * zRatio) + zRatio - 1 - gridOn), paintColor, BF: CALL mouseShow
	       img%(curXpos + imgXoffSet + 1, curYpos + imgYoffset + 1) = paintColor
   
	ELSEIF lb AND inRange(0, 189, 9, 199) THEN CALL scroll(-1, 0): CALL ResumeImgSub
	ELSEIF lb AND inRange(300, 190, 309, 199) THEN CALL scroll(1, 0): CALL ResumeImgSub
	ELSEIF lb AND inRange(310, 0, 319, 9) THEN CALL scroll(0, -1): CALL ResumeImgSub
	ELSEIF lb AND inRange(310, 180, 319, 189) THEN CALL scroll(0, 1): CALL ResumeImgSub
	ELSEIF lb AND inRange(311, 191, 319, 199) THEN
		CALL selectColor
		DO: CALL mouseStatus(lb, rb, MouseX, MouseY): LOOP UNTIL lb = 0 AND rb = 0
	ELSEIF lb AND inRange(42, 190, 169, 198) THEN paintColor = POINT(MouseX / 2, 195): CALL UpdateInfo
	ELSEIF lb AND inRange(289, 191, 298, 199) THEN CALL eyeDropperTool
	END IF
   
	IF rb AND inRange(0, 0, (zRatio * numXpix) - 1, (zRatio * numYpix) - 1) THEN
		curXpos = INT((MouseX / 2) / zRatio)
		curYpos = INT(MouseY / zRatio)

		CALL mouseHide: LINE ((curXpos * zRatio), (curYpos * zRatio))-((curXpos * zRatio) + zRatio - 1 - gridOn, (curYpos * zRatio) + zRatio - 1 - gridOn), paperColor, BF: CALL mouseShow
		img%(curXpos + imgXoffSet + 1, curYpos + imgYoffset + 1) = paperColor
	ELSEIF rb AND inRange(42, 190, 169, 198) THEN
		paperColor = POINT(MouseX / 2, 195): CALL UpdateInfo
	END IF

  LOOP UNTIL j$ <> ""
    IF j$ = CHR$(27) THEN
	CALL mouseHide: GOSUB menu
    ELSEIF j$ = "=" THEN
	IF zRatio < 20 THEN zRatio = zRatio + 1: CALL mouseHide: LINE (0, 0)-(300, 180), 8, BF: GOSUB resumeImg ELSE GOSUB mainloop
    ELSEIF j$ = "-" THEN
	IF zRatio = 2 THEN zRatio = zRatio - 1: gridOn = 0: CALL mouseHide: LINE (0, 0)-(300, 180), 8, BF: GOSUB resumeImg
	IF zRatio > 1 THEN zRatio = zRatio - 1: CALL mouseHide: LINE (0, 0)-(300, 180), 8, BF: GOSUB resumeImg ELSE GOSUB mainloop
    ELSEIF j$ = LCASE$("G") THEN
	IF gridOn THEN gridOn = 0: CALL mouseHide: GOSUB resumeImg
	IF zRatio > 1 THEN gridOn = 1: CALL mouseHide: LINE (0, 0)-(300, 180), 8, BF: GOSUB resumeImg
	GOSUB mainloop
    ELSEIF j$ = LCASE$("V") THEN
	CALL mouseHide: CALL viewTiled: GOSUB resumeImg
    ELSEIF j$ = LCASE$("F") THEN
	CALL mouseHide: CALL fillTool: GOSUB resumeImg
    ELSE
     GOSUB mainloop
    END IF


saveImg:
 CLS : PAINT (1, 1), 1: LINE (50, 40)-(272, 160), 9, B: PAINT (55, 55), 8, 9

  COLOR 15: LOCATE 8, 8: PRINT " Choose a file name for your"
  LOCATE 9, 8: PRINT "image, including extensions."
   imgArraySize = (4 + INT(((imgXsize + 1) * 8 + 7) / 8) * 1 * (imgYsize + 1)) / 2
   REDIM image%(imgArraySize)
  imgFileName$ = getString$(8, 12, 25)
   IF imgFileName$ = "" THEN GOSUB menu ELSE CALL saveImgSub(imgFileName$, imgArraySize)
   CLS : PAINT (1, 1), 8
   GOSUB resumeImg

loadImg:
 CLS : PAINT (1, 1), 1: LINE (50, 40)-(272, 160), 9, B: PAINT (55, 55), 8, 9

  COLOR 15: LOCATE 8, 8: PRINT " Choose a file name for the"
  LOCATE 9, 8: PRINT "image, including extensions"
   imgFileName$ = getString$(8, 12, 25)
    IF imgFileName$ = "" THEN GOSUB menu ELSE loadImgInfoSub (imgFileName$)
       
	REDIM img%(imgXsize, imgYsize)
	REDIM image%(imgArraySize)
	CALL loadImgSub(imgFileName$, imgArraySize)
 
	 zRatio = 10: gridOn = 1: editActive = 1: savedLastAction = 0
	 imgXoffSet = 0: imgYoffset = 0
	 paperColor = 0: paintColor = 1
       CLS : PAINT (1, 1), 8
       GOSUB resumeImg
  
getPalInfo:
 CALL mouseHide

 LINE (51, 61)-(271, 159), 8, BF: LINE (51, 41)-(271, 61), 0, BF: LINE (51, 65)-(271, 136), 0, BF

 LOCATE 10, 8: PRINT "Input the name of your"
 LOCATE 11, 8: PRINT "palette file.  Only A-Z,"
 LOCATE 12, 8: PRINT "a-z, 1-9 and . are allowed."
 LOCATE 13, 8: PRINT "(The file must be in the"
 LOCATE 14, 8: PRINT "same directory as the"
 LOCATE 15, 8: PRINT "currently active directory."
 LOCATE 16, 8: PRINT "Type STANDARD to bring back"
 LOCATE 17, 8: PRINT "the standard palette."


 LOCATE 7, 15: PRINT "Load Palette"
 palFileName$ = getString$(8, 19, 25)
 
  IF palFileName$ = "" THEN
	GOSUB menu
   ELSEIF LCASE$(palFileName$) = "standard" THEN
	PALETTE: GOSUB menu
   ELSE loadpal (palFileName$)
  END IF
 GOSUB menu

resizeImg:
 CLS : PAINT (1, 1), 1: LINE (50, 40)-(272, 160), 9, B: PAINT (55, 55), 8, 9
 LOCATE 8, 8: PRINT " Select the new sizes"
 LOCATE 9, 8: PRINT "for your image."
  preImgXsize = imgXsize: preImgYsize = imgYsize
  FOR y = 0 TO imgYsize
   FOR x = 0 TO imgXsize
    preImg%(x, y) = img%(x, y)
   NEXT x
  NEXT y

 LOCATE 11, 8: INPUT "X-size: "; imgXsize: IF imgXsize = 0 THEN imgXsize = 1: IF imgXsize > 100 THEN imgXsize = 100
	IF imgXsize < preImgXsize THEN preImgXsize = imgXsize
 LOCATE 13, 8: INPUT "Y-size: "; imgYsize: IF imgYsize = 0 THEN imgYsize = 1: IF imgYsize > 100 THEN imgYsize = 100
	IF imgYsize < preImgYsize THEN preImgYsize = imgYsize

 REDIM img%(imgXsize, imgYsize)
  FOR y = 0 TO preImgYsize
   FOR x = 0 TO preImgXsize
    img%(x, y) = preImg%(x, y)
   NEXT x
  NEXT y

  REDIM preImg%(imgXsize, imgYsize)

  LOCATE 15, 8: PRINT "Successful.  New sizes are:"
  LOCATE 16, 8: PRINT "x = "; imgXsize
  LOCATE 17, 8: PRINT "y = "; imgYsize
  LOCATE 19, 9: PRINT "press a key to continue..."
  DO: LOOP UNTIL INKEY$ <> ""

 CLS : PAINT (1, 1), 8: GOSUB resumeImg


MouseData:
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

'ErrorHandler:
 'IF ERR = BADFILENAME THEN
 ' LINE (50, 40)-(272, 160), 9, B: LINE (51, 41)-(271, 159), 8, BF: LINE (51, 76)-(271, 106), 0, BF
 ' LOCATE 11, 8: PRINT "File does not exist in"
 ' LOCATE 12, 8: PRINT "this directory."
 ' LOCATE 13, 8: PRINT " Press a key to continue."
 '       DO: LOOP UNTIL INKEY$ <> ""
 ' RESUME menu
 'END IF
 '
 'IF ERR = NORESUME THEN RESUME menu

REM $STATIC
SUB delay (dly!)
curTime! = TIMER
WHILE curTime! + dly! > TIMER
WEND
END SUB

SUB drawImg
  FOR y = 1 TO imgYsize
   FOR x = 1 TO imgXsize
    LINE (x * zRatio, y * zRatio)-((x * zRatio) + zRatio, (y * zRatio) + zRatio), img(x, y), BF
   NEXT x
  NEXT y
 
END SUB

SUB drawXscroll
 LINE (0, 189)-(9, 199), 15, B
  LINE (7, 194)-(2, 194), 15: LINE (2, 194)-(4, 192), 15: LINE (2, 194)-(4, 196), 15

 LINE (300, 190)-(309, 199), 15, B
  LINE (302, 194)-(307, 194), 15: LINE (307, 194)-(305, 192), 15: LINE (307, 194)-(305, 196), 15
END SUB

SUB drawYscroll
 LINE (310, 0)-(319, 9), 15, B
  LINE (314, 7)-(314, 2), 15: LINE (314, 2)-(312, 4), 15: LINE (314, 2)-(316, 4), 15

 LINE (310, 180)-(319, 189), 15, B
  LINE (314, 182)-(314, 187), 15: LINE (314, 187)-(312, 185), 15: LINE (314, 187)-(316, 185), 15

END SUB

SUB eyeDropperTool
mouseHide: LINE (298, 191)-(289, 199), 15, BF: mouseShow
DO
 CALL mouseStatus(lb, rb, MouseX, MouseY)

 IF lb AND inRange(0, 0, (zRatio * numXpix) - 1, (zRatio * numYpix) - 1) THEN
	curXpos = INT((MouseX / 2) / zRatio)
	curYpos = INT(MouseY / zRatio)

 CALL mouseHide: paintColor = POINT((curXpos * zRatio), (curYpos * zRatio)): CALL UpdateInfo: CALL mouseShow: EXIT DO
 END IF


 IF rb AND inRange(0, 0, (zRatio * numXpix) - 1, (zRatio * numYpix) - 1) THEN
	curXpos = INT((MouseX / 2) / zRatio)
	curYpos = INT(MouseY / zRatio)

 CALL mouseHide: paperColor = POINT((curXpos * zRatio), (curYpos * zRatio)): CALL UpdateInfo: LINE (299, 192)-(288, 198), 8, BF: CALL mouseShow: EXIT DO
 END IF
LOOP
 
END SUB

SUB fillTool
 FOR y = 1 TO imgYsize
  FOR x = 1 TO imgXsize
   img%(x, y) = paintColor
  NEXT
 NEXT
END SUB

FUNCTION getString$ (x, y, maxlength)

 LINE ((x * 8) - 10, (y * 8) - 10)-((x * 8) + ((maxlength) * 8) + 1, (y * 8) + 1), 15, B
 LINE ((x * 8) - 9, (y * 8) - 9)-((x * 8) + ((maxlength) * 8), (y * 8)), 0, BF

fileName$ = ""

getCharacters:

DO
SLEEP 0: j$ = INKEY$
   
    'if escape
    IF j$ = CHR$(27) THEN fileName$ = "": EXIT FUNCTION

    'if backspace:
    IF j$ = CHR$(8) THEN IF LEN(fileName$) > 0 THEN fileName2$ = LEFT$(fileName$, (LEN(fileName$) - 1)): fileName$ = fileName2$: LOCATE y, x: PRINT fileName$ + " "
   
    'if enter
    IF j$ = CHR$(13) THEN EXIT DO
   
    'if a letter, number, or "."
    IF (j$ >= CHR$(48) AND j$ <= CHR$(57)) OR (j$ >= CHR$(65) AND j$ <= CHR$(90)) OR (j$ >= CHR$(97) AND j$ <= CHR$(122)) OR j$ = CHR$(46) THEN
     IF LEN(fileName$) <= maxlength THEN
      fileName$ = fileName$ + j$: LOCATE y, x: PRINT fileName$
     ELSE BEEP
     END IF
    END IF
 LOOP

 IF fileName$ > "" THEN getString$ = fileName$ ELSE BEEP: GOSUB getCharacters
END FUNCTION

FUNCTION inRange (x1, y1, x2, y2)

IF MouseX / 2 >= x1 AND MouseY >= y1 AND MouseX / 2 <= x2 AND MouseY <= y2 THEN inRange = -1

END FUNCTION

SUB limitRange (x1, y1, x2, y2)
 
Ax = 7
Cx = x1 * 2
Dx = x2 * 2
MouseDriver Ax, 0, Cx, Dx
Ax = 8
Cx = y1
Dx = y2
MouseDriver Ax, 0, Cx, Dx

END SUB

SUB loadImgInfoSub (imgFileName$)

 OPEN imgFileName$ FOR INPUT AS #1
  INPUT #1, imgXsize, imgYsize
  INPUT #1, imgArraySize
 CLOSE #1

END SUB

SUB loadImgSub (imgFileName$, imgArraySize)

 OPEN imgFileName$ FOR INPUT AS #1
  INPUT #1, a, a
  INPUT #1, a
   FOR i = 0 TO imgArraySize
     INPUT #1, image%(i)
   NEXT i
 CLOSE #1

  CLS
  PUT (0, 0), image%
  FOR y = 0 TO imgYsize
   FOR x = 0 TO imgXsize
    img%(x, y) = POINT(x, y)
   NEXT x
  NEXT y
  CLS

END SUB

SUB loadpal (pal$)

'------------Load the palette into memory------------

 OPEN pal$ FOR INPUT AS #1

  FOR i% = 0 TO 255
	INPUT #1, pal(i%).r
	INPUT #1, pal(i%).g
	INPUT #1, pal(i%).B
  NEXT i%

 CLOSE #1

'---------Send the data to the graphics card---------

 OUT &H3C8, 0

 FOR i% = 0 TO 255

  OUT &H3C9, pal(i%).r
  OUT &H3C9, pal(i%).g
  OUT &H3C9, pal(i%).B

 NEXT i%

END SUB

SUB MouseDriver (Ax, Bx, Cx, Dx)
 
DEF SEG = VARSEG(Mouse$)
Mouse = SADD(Mouse$)
CALL Absolute(Ax, Bx, Cx, Dx, Mouse)

END SUB

SUB mouseHide

Ax = 2
MouseDriver Ax, 0, 0, 0

END SUB

FUNCTION MouseInit
 
Ax = 0
MouseDriver Ax, 0, 0, 0
MouseInit = Ax

END FUNCTION

SUB MouseLoad

Mouse$ = SPACE$(57)

RESTORE MouseData

FOR i = 1 TO 57
 READ a$
 H$ = CHR$(VAL("&H" + a$))
 MID$(Mouse$, i, 1) = H$
NEXT i

IF NOT MouseInit THEN
 PRINT "Mouse not found."
 END
END IF

CALL limitRange(0, 0, 319, 199)

END SUB

SUB mousePut (x, y)

Ax = 4
Cx = x * 2
Dx = y
MouseDriver Ax, 0, Cx, Dx

END SUB

SUB mouseShow
 
Ax = 1
MouseDriver Ax, 0, 0, 0

END SUB

SUB mouseStatus (lb, rb, xMouse, yMouse)
 
Ax = 3
MouseDriver Ax, Bx, Cx, Dx
lb = ((Bx AND 1) <> 0)
rb = ((Bx AND 2) <> 0)
MouseX = Cx
MouseY = Dx

END SUB

SUB ResumeImgSub
       
	'how many virtual pixels?
	IF (zRatio * imgXsize) <= 300 THEN numXpix = imgXsize: yScroll = 0: LINE (0, 189)-(9, 199), 8, BF: LINE (300, 190)-(309, 199), 8, BF ELSE numXpix = INT(300 / zRatio): xScroll = 1: CALL drawXscroll
	IF (zRatio * imgYsize) <= 180 THEN numYpix = imgYsize: yScroll = 0: LINE (310, 0)-(319, 9), 8, BF: LINE (310, 180)-(319, 189), 8, BF ELSE numYpix = INT(180 / zRatio): yScroll = 1: CALL drawYscroll
	 LINE (311, 191)-(319, 199), 15, B

	 LINE (289, 191)-(298, 199), 15, B

	IF numXpix > (imgXsize - imgXoffSet) THEN imgXoffSet = (imgXsize - numXpix)
	IF numYpix > (imgYsize - imgYoffset) THEN imgYoffset = (imgYsize - numYpix)

	FOR y = 0 TO numYpix - 1
	 FOR x = 0 TO numXpix - 1
	    LINE ((x * zRatio), (y * zRatio))-((x * zRatio) + zRatio - 1 - gridOn, (y * zRatio) + zRatio - 1 - gridOn), img%(x + 1 + imgXoffSet, y + 1 + imgYoffset), BF
	 NEXT x
	NEXT y
      
  CALL UpdateInfo: CALL mouseShow

END SUB

SUB saveImgSub (fileName$, imgArraySize)

CLS

 FOR y = 1 TO imgYsize
  FOR x = 1 TO imgXsize
   PSET (x, y), img%(x, y)
  NEXT x
 NEXT y

 GET (0, 0)-(imgXsize, imgYsize), image%

 OPEN fileName$ FOR OUTPUT AS #1
  WRITE #1, imgXsize, imgYsize
  WRITE #1, imgArraySize

  FOR i = 0 TO imgArraySize
   PRINT #1, image%(i)
  NEXT i

 CLOSE #1

savedLastAction = 1

END SUB

SUB scroll (x, y)
 
 IF x > 0 THEN IF (imgXoffSet + numXpix) < imgXsize THEN imgXoffSet = imgXoffSet + 1
 IF x < 0 THEN IF imgXoffSet > 0 THEN imgXoffSet = imgXoffSet - 1
 IF y > 0 THEN IF (imgYoffset + numYpix) < imgYsize THEN imgYoffset = imgYoffset + 1
 IF y < 0 THEN IF imgYoffset > 0 THEN imgYoffset = imgYoffset - 1

 delay delayTime!
END SUB

SUB selectColor
 LINE (180, 60)-(310, 190), 15, B: LINE (181, 61)-(309, 189), 0, BF

colorNumber = 0

FOR y = 0 TO 15
  FOR x = 0 TO 15
    LINE ((x * 8) + 181, (y * 8) + 61)-((x * 8) + 189, (y * 8) + 69), colorNumber, BF
    colorNumber = colorNumber + 1
  NEXT x
 NEXT y

paintX = paintColor MOD 16
  paintY = paintColor / 16
  LINE ((paintX * 8) + 181, (paintY * 8) + 61)-((paintX * 8) + 188, (paintY * 8) + 68), 15, B
 
  paperX = paperColor MOD 16
  paperY = paperColor / 16
  LINE ((paperX * 8) + 181, (paperY * 8) + 61)-((paperX * 8) + 188, (paperY * 8) + 68), 15, B

 DO: CALL mouseStatus(lb, rb, MouseX, MouseY): LOOP UNTIL lb = 0 AND rb = 0

colorLoop:
 DO
  CALL mouseStatus(lb, rb, MouseX, MouseY)
  IF lb AND inRange(181, 61, 309, 189) THEN
	curXpos = INT(((MouseX / 2) - 180) / 8)
	curYpos = INT((MouseY - 60) / 8)
		previousColor(previousColorNum) = paintColor: previousColorNum = previousColorNum + 1: IF previousColorNum = 17 THEN previousColorNum = 1
		CALL UpdateInfo: paintColor = (curYpos * 16) + curXpos: EXIT DO
  ELSEIF rb AND inRange(181, 61, 309, 189) THEN
	curXpos = INT(((MouseX / 2) - 180) / 8)
	curYpos = INT((MouseY - 60) / 8)
		previousColor(previousColorNum) = paintColor: previousColorNum = previousColorNum + 1: IF previousColorNum = 17 THEN previousColorNum = 1
		CALL UpdateInfo: paperColor = (curYpos * 16) + curXpos: EXIT DO
  END IF
 
 LOOP

CALL mouseHide: LINE (180, 60)-(310, 190), 8, BF: CALL ResumeImgSub
     
END SUB

SUB UpdateInfo

 LINE (11, 189)-(30, 199), 15, B
 LINE (12, 190)-(19, 198), paintColor, BF
 LINE (22, 190)-(29, 198), paperColor, BF

 LINE (41, 189)-(170, 199), 15, B
 FOR i = 0 TO 15
  LINE ((i * 8) + 42, 190)-((i * 8) + 49, 198), previousColor(i + 1), BF
 NEXT

END SUB

SUB viewTiled

 CLS
  FOR y = 0 TO INT(200 / imgYsize)
   FOR x = 0 TO INT(320 / imgXsize)
    FOR y2 = 1 TO imgYsize
     FOR x2 = 1 TO imgXsize
      PSET ((x * imgXsize) + x2, (y * imgYsize) + y2), img%(x2, y2)
     NEXT x2
    NEXT y2
   NEXT x
  NEXT y

DO: LOOP UNTIL INKEY$ <> ""
 CLS
END SUB

